/**<pre>
 * Title: Navigator
 * Copyright: Copyright (c) 2002
 * Company:   University of Oregon Computer Science Dept.
 *
 * @author Jason Prideaux
 * @version 1.0
 * </pre>
 */

package app.navigator.core;

import app.navigator.util.*;
import app.navigator.poi.*;
import app.navigator.gui.*;
import app.*;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Date;
import java.io.*;



public class Navigator{


	private NavFrame frame;

	private Vector pois;

	private Position current;

	private POI destination;


	//
	public Navigator(NavFrame frame){

		this.frame = frame;

		POIParser poip= new POIParser("poi.xml");
		pois = poip.getPOIs();

		//this should be removed later
		//destination = (POI)(pois.elementAt(0));


	} //Constructor






  	//
    public void updatePos(HashMap table, String id){

		try{

			//we could also check to see if we are at destination here.
			//and calculate directions here.

			if( destination != null ){

				current = (Position)(table.get(id));

				Point pos1 = frame.getChartComp().getChartData().transPos((Position)(table.get(id)));
				Point pos2 = frame.getChartComp().getChartData().transPos(destination.getPosition());

				double x = pos1.getX() - pos2.getX();
				double y = pos1.getY() - pos2.getY();

				double diff = Math.sqrt( x*x + y*y );

				double heading = Math.toDegrees( Math.asin( y/diff ) );
				//make from 0 to 360 values.
				if( pos1.x < pos2.x ){
					if( heading < 0 )
						heading += 360;
				}else{
					heading = 180 - heading;
				}

				//System.out.println( "    "+heading);
				frame.getChartComp().setDest(heading, pos2);
			}


		}catch(Exception e){}

	}



	public Vector getPOIs(){
		return pois;
	}


	public void setDest(POI p){
		destination = p;
	}

	public void setDest(String name){
		//find the dest in pois

		System.out.println(" finding .... "+name );

		for(int i=0; i< pois.size(); i++ ){
			if( name.equals( ((POI)(pois.elementAt(i))).getName() ) ){
				destination = (POI)(pois.elementAt(i));
			}
		}

	}

	public void resetDest(){
		destination = null;
		frame.getChartComp().resetDest();
	}


} //class: