/**<pre>
 * Title: Easy GPS
 * Copyright: Copyright (c) 2002
 * Company:   University of Oregon Computer Science Dept.
 *
 * @author Jason Prideaux, adapted from Richard Caudle
 * @version 1.0
 * </pre>
 */

package app.navigator.gui;

import app.navigator.util.*;
import app.navigator.poi.*;
import app.navigator.core.*;
import app.*;
import cat.sig.*;
import cat.app.*;
import cat.util.*;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Date;
import java.io.*;



public class NavFrame extends Frame implements ActionListener, ItemListener{


	boolean alwaysCenter=true;

	Dialog notification;

	Image background;
	ChartComp chart;
	ScrollPane pane;
	Label stat = new Label("");
	Panel panel1;

	Panel panel2;
	Label l1;
	Label dest;
	Choice chooser;
	Label l2;

	Panel btnpanel;

	Panel impanel;

	Panel profpanel;

	//Label sen = new Label("Message to send:");
	//Label rcv = new Label("Received messages:");
	TextArea rcvfld = new TextArea("",100,20,TextArea.SCROLLBARS_VERTICAL_ONLY);
	TextArea sndfld = new TextArea("",2,20,TextArea.SCROLLBARS_NONE);
	Button send = new Button("Send");
	Label chat;


	private int mode;

	private NavApp parent;

	private HashMap agenttable = new HashMap();

	private Vector friends = new Vector();

	private String current;

	private Navigator navigator;




	//Constructs a UI which is used by 'widget' and displays info on 'user'
	public NavFrame(String user, NavApp parent){

		super("Navigator - "+user);
		//setSize(240,300);
		setSize(370,603);

		mode = 1;
		this.parent = parent;

		navigator = new Navigator(this);

		setLocation(0,0);
		setLayout(null);

		this.addWindowListener(new WindowAdapter(){
	  		public void windowClosing(WindowEvent e)
			{
				System.exit(0);
			}
		});

		Toolkit tool = Toolkit.getDefaultToolkit();   //gotta love tool
		try{
			byte[] b = new byte[26000];
			FileInputStream fis = new FileInputStream("files/app/images/ipaq.jpg");
			fis.read(b);

			background = tool.createImage(b);
		}catch(Exception e){}




		//Create impanel
		impanel = new Panel(null);
		impanel.setBounds( 63, 161, 240, 245);

		chat = new Label("Chatting with: ");
		chat.setBounds( 8, 16, 240, 20);

		rcvfld.setBounds( 8,36,224,140 );
		rcvfld.setEditable(false);
		rcvfld.setBackground(Color.white);
		sndfld.setBounds( 8,195,160,40 );
		send.setBounds( 175,205,50,20 );

		send.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				send_actionPerformed(e);
			}
		});

		impanel.add(chat);
		impanel.add(rcvfld);
		impanel.add(sndfld);
		impanel.add(send);


		//Create btnpanel
		btnpanel = new Panel(null);
		btnpanel.setBounds( 63, 410, 240, 35);

		Button b1 = new Button("View Map");
		b1.setName("1");
		b1.setBounds( 20, 5, 90, 20);
		Button b2 = new Button("Destinations");
		b2.setName("2");
		b2.setBounds( 130, 5, 90, 20);

		b1.addActionListener(this);
		b2.addActionListener(this);

		btnpanel.add(b1);
		btnpanel.add(b2);


        //Create panel1
		panel1 = new Panel(null);
		panel1.setBounds( 63, 161, 240, 245);

    	pane=new ScrollPane(ScrollPane.SCROLLBARS_NEVER);

    	chart = new ChartComp(this, true, 1);
    	pane.add(chart);
		pane.setBounds( 8,16,224,200 );

		Label lz = new Label("Zoom:");
		lz.setBounds( 73, 220, 50, 20);

		Button z1 = new Button(" + ");
		z1.setName("99");
		z1.setBounds( 130, 220, 40, 20);
		Button z2 = new Button(" - ");
		z2.setName("99");
		z2.setBounds( 180, 220, 40, 20);

		z1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					chart.zoomIn();
				}
			});
		z2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					chart.zoomOut();
				}
			});

		panel1.add(z1);
		panel1.add(z2);
		panel1.add(lz);
		panel1.add(pane);


		//Create panel2
		panel2 = new Panel(null);
		panel2.setBounds( 63, 161, 240, 245);

		l1 = new Label("Current Destination:");
		l1.setBounds( 8, 16, 240, 20);

		dest = new Label(" - ");
		dest.setBounds( 8, 36, 240, 20);

		l2 = new Label("Choose a destination:");
		l2.setBounds( 8, 60, 240, 20);

		chooser = new Choice();
		chooser.setBounds( 12, 80, 220, 20);
		Vector pois = navigator.getPOIs();
		for(int i=0; i<pois.size(); i++ ){
			chooser.add( ((POI)(pois.elementAt(i))).getName()  );
		}

		chooser.addItemListener(this);

		panel2.add(l1);
		panel2.add(l2);
		panel2.add(dest);
		panel2.add(chooser);

		//Finish the frame
		add(panel1);
		add(btnpanel);


	} //Constructor


	public void itemStateChanged(ItemEvent e){

		System.out.println( chooser.getSelectedItem() );
		dest.setText("  "+chooser.getSelectedItem() );

		//navigator
		navigator.setDest( chooser.getSelectedItem() );
	}



   	/* ====================================================================== */
	/** This
	 *
	 *  @param  g
	 *
	 */
   	public void paint(Graphics g) {

		// paint any space not covered
     	super.paint(g);

      	// If we have a valid width and height for the
       	// background image, draw it.

         g.drawImage(background,0,23,this);

   	} //method: paintComponent



	public void actionPerformed(ActionEvent a){

		Object obj = a.getSource();
		if( obj instanceof Button ){

			String s = ((Button)obj).getName();

			if( mode == 1 && Integer.parseInt(s) == 2 ){
				mode = 2;
				this.remove(panel1);
				this.add(panel2);

			}else if( mode == 2 && Integer.parseInt(s) == 1 ){
				mode = 1;
				this.remove(panel2);
				this.add(panel1);

			}else if( mode == 3 && Integer.parseInt(s) == 1 ){
				mode = 1;
				this.remove(impanel);
				this.add(panel1);

			}else if( mode == 3 && Integer.parseInt(s) == 2 ){
				mode = 2;
				this.remove(impanel);
				this.add(panel2);


			}else if( mode == 4 && Integer.parseInt(s) == 1 ){
				mode = 1;
				this.remove(profpanel);
				this.add(panel1);


			}else if( mode == 4 && Integer.parseInt(s) == 2 ){
				mode = 2;
				this.remove(profpanel);
				this.add(panel2);

			}

		}
	}


	public void incoming(Agent a, String s){

		rcvfld.append(""+a.getId() +" > "+s+"\n");

		if( mode == 1 || mode == 2 || mode == 4){

			rcvfld.setText(""+a.getId() +" > "+s+"\n");

			notification = new Dialog(this, "IM Notification");
			notification.setSize(200,100);
			Point pos = this.getLocation();
			notification.setLocation(pos.x + 80, pos.y+200);

			Panel p = new Panel(null);
			p.setBounds( 0, 23, 200, 87);

			Label l = new Label(""+a.getId()+" would like to chat.");
			l.setBounds( 10, 10, 180, 20);

			Button b = new Button("Let's chat.");
			b.setName(a.getId());
			b.setBounds( 10, 35, 70, 23);

			Button b2 = new Button("Not right now.");
			b2.setName(a.getId());
			b2.setBounds( 90, 35, 90, 23);

			p.setBackground(Color.white);
			p.add(l);
			p.add(b);
			p.add(b2);

			b.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					im_actionPerformed(e);
				}
			});
			b2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					notification.dispose();
				}
			});
			notification.addWindowListener(new WindowAdapter(){
				public void windowClosing(WindowEvent e){
					notification.dispose();
				}
			});

			notification.add(p);
			notification.setVisible(true);

		}
	}


	public void im_actionPerformed(ActionEvent e){

		Button btn = (Button)(e.getSource());
		String id = btn.getName();
		current = id;

		if( friends.contains(id) ){

			try{
				notification.dispose();
			}catch(Exception exc){}

			chat.setText("Chatting with: " + id);
			send.setName(id);
			if( mode == 1){
				this.remove(panel1);
			}else if( mode == 2){
				this.remove(panel2);
			}
			mode = 3;

			this.add(impanel);

		}else{

			notification = new Dialog(this, "Make a friend");
			notification.setSize(200,100);
			Point pos = this.getLocation();
			notification.setLocation(pos.x + 80, pos.y+200);

			Panel p = new Panel(null);
			p.setBounds( 0, 23, 200, 87);

			Label l = new Label("Send a friend request to "+id+".");
			l.setBounds( 10, 10, 180, 20);

			Button b = new Button("Ok");
			b.setName(id);
			b.setBounds( 25, 35, 60, 23);

			Button b2 = new Button("Cancel");
			b2.setName(id);
			b2.setBounds( 115, 35, 60, 23);

			p.setBackground(Color.white);
			p.add(l);
			p.add(b);
			p.add(b2);

			b.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					notification.dispose();
					parent.formFriendSig(current);
				}
			});
			b2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					notification.dispose();
				}
			});
			notification.addWindowListener(new WindowAdapter(){
				public void windowClosing(WindowEvent e){
					notification.dispose();
				}
			});

			notification.add(p);
			notification.setVisible(true);


		}
	}


	public void newFriend(String id){

		friends.add(id);
		agenttable = new HashMap();

	}


	public void send_actionPerformed(ActionEvent e){

		Button btn = (Button)(e.getSource());
		String id = btn.getName();
		Agent a = (Agent)(agenttable.get(id));

		String msg = sndfld.getText();
		msg.replaceAll("\n", "");

		sndfld.setText("");
		rcvfld.append("You > "+msg+"\n");

		System.out.println("Need to send our message to : "+id);
		ContextApp.p2pSend(a,msg);


	}




	//let us know when an agent was selected in the map.
	public void selectAgent(String id){

		//should give a pop up window with information about
		//the closest poi.

		/*System.out.println("You selected an agent : "+id);
		mode = 4;
		//this.remove(panel1);
		//this.add(panel2);
		this.remove(panel1);
		Agent a = (Agent)(agenttable.get(id));
		if( id.equals(iSIM.ID) )
			profpanel = new ProfilePanel( a, true );
		else
			profpanel = new ProfilePanel( a, false );

		this.add(profpanel);*/

	}



	public ChartComp getChartComp(){
    	return(chart);
  	}




  	//public void updatePos(Point pos, Point pred){
    public void updatePos(HashMap table, String id){

		try{
			Point pos = chart.getChartData().transPos((Position)(table.get(id)));

			//also update the Navigator
			navigator.updatePos(table, id);

			try{
				chart.updatePos(table, id);
				chart.paint();
			}catch(Exception e){}

			Point p=pane.getScrollPosition();
			Dimension d=pane.getViewportSize();
			Point p2=new Point(p);

			if( alwaysCenter ){
				p2.y=(int)(chart.getZoomFactor()*pos.y)-(d.height)/2;
				p2.x=(int)(chart.getZoomFactor()*pos.x)-(d.width)/2;
			}

			if (!p2.equals(p)){
			  pane.setScrollPosition(p2);
			}

		}catch(Exception e){}

	}


	public void updateInfo(HashMap table, String aid){


		/*java.util.Collection newset = table.keySet();
		java.util.Collection oldset = agenttable.keySet();

		if( newset.size() != oldset.size() || !(newset.equals(oldset)) ){

			agenttable = (HashMap)(table.clone());

			l1 = new Label("Current Destination:");
			l1.setBounds( 8, 16, 240, 20);

			l2 = new Label("Choose a destination:");
			l2.setBounds( 8, 60, 240, 20);

			panel2.removeAll();
			panel2.add(l1);
			panel2.add(l2);

			java.util.Collection all = table.keySet();
			Object[] objs = all.toArray();

			String id ="";
			int offset = 0;
			int start = 84;

			for (int i=0; i<objs.length; i++) {
				id = (String)objs[i];

				//now draw it
				Label l = new Label(id);
				Button b = new Button("IM "+id);
				b.setName(id);
				l.setBounds( 15,80 + ((i-offset)*20),100,20 );
				b.setBounds( 115,80 + ((i-offset)*20),100,20 );

				if( aid.equals(id) ){
					l.setBounds( 15,36,100,20 );
					offset = 1;
					l.setForeground(Color.red);
					panel2.add(l);
				}else if( friends.contains(id) ){
					start+=20;
					panel2.add(b);
					b.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(ActionEvent e) {
							im_actionPerformed(e);
						}
					});
					l.setForeground(Color.blue);
					panel2.add(l);
				}else{
					offset += 1;
				}

			}


		}*/


	}




} //class: