/**<pre>
 * Title: Easy GPS
 * Copyright: Copyright (c) 2002
 * Company:   University of Oregon Computer Science Dept.
 *
 * @author Jason Prideaux, adapted from Richard Caudle
 * @version 1.0
 * </pre>
 */

package app.navigator.gui;

import app.navigator.util.*;
import app.*;
import cat.sig.*;
import cat.app.*;
import cat.util.*;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Date;
import java.io.*;



public class ProfilePanel extends Panel{



	Label name = new Label("Name:");
	Label avail = new Label("Available?:");
	Label loc = new Label("Location:");
	TextField namefld = new TextField("");
	TextField availfld = new TextField("");
	TextField locfld = new TextField("");

	Button save = new Button("Save");
	Button cancel = new Button("Cancel");
	Label title;

	Agent agent;


	//Constructs a UI which is used by 'widget' and displays info on 'user'
	public ProfilePanel(Agent a, boolean us){

		super(null);

		this.agent = a;
		//Create impanel
		this.setBounds( 63, 161, 240, 245);

		if( us ){
			title = new Label("Your profile: ");
		}else{
			title = new Label(""+a.getId()+ "'s profile: ");
		}
		title.setBounds( 8, 16, 240, 20);


		name.setBounds( 8,36,100,20 );
		loc.setBounds( 8,60,100,20 );
		avail.setBounds( 8,86,100,20 );

		namefld.setBounds( 110,36,100,20 );
		locfld.setBounds( 110,60,100,20 );
		availfld.setBounds( 110,86,100,20 );

		namefld.setText(a.getProfile().getName());
		locfld.setText(a.getProfile().getLocation());
		availfld.setText((new Boolean(a.getProfile().isAvailable())).toString());

		save.setBounds( 30,205,70,20 );

		save.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				save_actionPerformed(e);
			}
		});

		cancel.setBounds( 120,205,70,20 );

		cancel.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cancel_actionPerformed(e);
			}
		});

		this.add(title);
		this.add(name);
		this.add(loc);
		this.add(avail);
		this.add(namefld);
		this.add(locfld);
		this.add(availfld);
		if(us){
			this.add(save);
			this.add(cancel);
		}



	} //Constructor






	public void save_actionPerformed(ActionEvent e){

		iSIM.PSUEDONAME = namefld.getText();

	}

	public void cancel_actionPerformed(ActionEvent e){

		namefld.setText(iSIM.PSUEDONAME);
		locfld.setText(iSIM.LOCATION);
		availfld.setText((new Boolean(iSIM.AVAILABLE)).toString());

	}



} //class: