/**<pre>
 * Title: GPS Simulator
 * Copyright: Copyright (c) 2002
 * Company:   University of Oregon Computer Science Dept.
 *
 * @author Jason Prideaux
 * @version 1.0
 * </pre>
 */

package app.navigator.poi;

import app.navigator.util.*;

/* ====================================================================== */
/** This class represents a gps position location, a gps position contains
 *  the latitude, longitude, heading, and other information.
 *
 */
public class POI implements java.io.Serializable{

	/** Latitude. */
  	private Position pos;

	/** Longitude. */
  	private String name;




    /* ===================================================================== */
    /** This constructor instantiates the GPS Position object with default
     *  values for the gps coordinate position.  All variables are set as the
     *  system gets them.
     *
     */
	public POI(Position pos, String name){

  		this.pos = pos;
  		this.name = name;


	} //Constructor



    /* ===================================================================== */
    /** This method returns the time.
     *
     *  @return  long   The time in millisecons currently.
     *
     */
	public Position getPosition(){

		return pos;

	} //method: getTime




    /* ===================================================================== */
    /** This method returns the heading.
     *
     *  @return  double   The heading as a double.
     *
     */
	public String getName(){

		return name;

	} //method: getHeading




    /* ===================================================================== */
    /** This method returns a String of the GPS Position in a NMEA format.
     *
     *  @return  String   The nmea String for this Position object.
     *
     */
  	public String toString(){

    	return(name+" "+
     	pos.getLatitude()+", "+
     	pos.getLongitude() );

  	} //method: toString


} //class: POI

